#version 130
#extension GL_EXT_gpu_shader4 : enable
// the version and open GL extension
// should be the first line of the shader
/////////////////////////////////////////////////////////////////////////////////
//Why we walkMod01.fsh   by   Eiffie 
//https://www.shadertoy.com/view/sdjczG
//Licence : Creative Commons Attribution-ShareAlike 4.0
//http://creativecommons.org/licences/by-sa/4.0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;
uniform sampler2D texture3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

//Why We Walk in Circles by eiffie (X marks the spot)

//https://www.sciencefocus.com/news/humans-may-have-an-ancient-ability-to-sense-magnetic-fields/

//Blindfolded we walk in circles as tight as 20 meters. What removed that ability?.

//Characteristics for the Occurence of a High-Current Z-Pinch Aurora
//as Recorded in Antiquity, Anthony L Peratt

//The Z-Machine at Sandia Labs produces 2 billion degrees using a z-pinch.
//It takes 3 billion to fuse silica into iron, more than a hundred times 
//hotter than the center of the sun.

//In the Nazca desert lines are produced by scraping away a layer of reddish
//iron rich soil to reveal the light sand below. Don't say they didn't warn you.

#define tim iTime*.3
#define rez iResolution.xy //0.628318
// Based on a simple 2d noise algorithm contributed by Trisomie21 (Thanks!) 
float noyz(vec2 v){ 
  vec4 h=fract(sin(vec4(floor(v.x)+floor(v.y)*1000.)+vec4(0,1,1000,1001))*1000.); 
  v=smoothstep(0.,1.,fract(v));return mix(mix(h.x,h.y,v.x),mix(h.z,h.w,v.x),v.y); 
}
float bumpz(vec2 p, float d){
  return (noyz(p)+noyz(vec2(p.x+p.y,p.x-p.y)))*d;
}
//smin from iq
float smin(float a,float b,float k){float h=clamp(0.5+0.5*(b-a)/k,0.0,1.0);return b+h*(a-b-k+k*h);}
float tube(vec2 pa, vec2 ba){return length(pa-ba*clamp(dot(pa,ba)/dot(ba,ba),0.0,1.0));}
float DE(vec2 p){p*=1.+p.x*0.02;p.x*=.8; 
  float r=length(p)-.57;
  vec2 k=p;k.x=abs(k.x)-.77;
  float r2=length(k)-.28;
  k=p;k.x=abs(k.x)-2.;
  float r3=length(k)-1.+p.x*.05;
  if(p.x>0.)r3=max(r3,-(length(p-vec2(2.5,0.))-.57));
  k=abs(p)-vec2(0.,.29);k.y-=k.x*k.x*0.09;
  float t=tube(k,vec2(.9,1.6))-.12;
  t=min(t,tube(k-vec2(.9,1.6),vec2(2.5,.21))-.12);
  t=min(t,tube(p-vec2(1.9,0.),vec2(.6,0.))-.12);
  float t2=tube(k-vec2(.6,.07),vec2(.6,1.))-.12;
  t2=min(t2,tube(k-vec2(.6,.07)-vec2(.6,1.),vec2(2.2,.18))-.12);
  r=smin(min(r,min(r3,t2)),min(r2,t),.36);
  float d=min(abs(r),abs(p.x+p.y+7.));
  return d;
}
vec2 rotate(vec2 v, float angle) {return cos(angle)*v+sin(angle)*vec2(v.y,-v.x);}
#define O fragColor
#define U fragCoord
//void mainImage(out vec4 O, in vec2 U){
//void mainImage( out vec4 fragColor, in vec2 fragCoord )
///////////////////////////////////////////////////////////////////////////////// 
// need to convert this from a void to a function and call it by adding
// a void main(void) { to the end of the shader
// what type of variable will the function return?, it is a color and needs to be a vec4
// change void to vec4 
//void MainImage(out vec4 fragColor, in vec2 fragCoord) 
vec4 mainImage( out vec4 O, in vec2 U )
{  
  vec2 uv=(2.0*U-rez)/rez;
  uv.xy*=(1.75+.5*sin(tim)+uv.y*.4);
  uv+=vec2(sin(tim*.7),sin(tim*.5))*.2;
  uv=rotate(uv,(tim+sin(tim))*1.3);
  float d=DE(uv*5.);
  d=.75-.4*pow(bumpz(uv*(30.+3.*sin(uv.yx*2.)),d),.25);
  fragColor =vec4(mix(vec3(1.,.7,.4)*d,vec3(1),clamp(d*d*d,0.,1.)),1.0);
/////////////////////////////////////////////////////////////////////////////////
//the function needs to return a value. 
//it needs to be a vec4
//we will return the varable fragColor 
// usual place for fragColor = vec4( color, 1.0 ); bring the } down below
return fragColor; 
}

///////////////////////////////////////////////////////////////////////////////// 
void main(void) { // this will be run for every pixel of gl_FragCoord.xy
vec4 vTexCoord = gl_TexCoord[0];
vec4 fragColor = vec4(1.0); // initialize variable fragColor as a vec4 
vec4 cc = mainImage(fragColor, gl_FragCoord.xy); // call function mainImage and assign the return vec4 to cc
gl_FragColor = vec4(cc) * gl_Color; // set the pixel to the value of vec4 cc  and..
//gl_FragColor.a = length(gl_FragColor.rgb);
}

// ..uses the values of any Color: or Opacity:
// clauses (and any Animate clauses applied to these properties) 
// appearing in the Sprite, Quad or other node invoking the shader 
// in the .scn file.

